#!/usr/bin/env dart
import 'package:disposable/collection.dart';
import 'package:disposable/disposable.dart';

class MyResource implements Disposable {
  bool _isDisposed = false;

  @override
  bool get isDisposed => _isDisposed;

  @override
  void dispose() {
    _isDisposed = true;
  }
}

main() {
  final r0 = new MyResource();
  final r1 = new MyResource();
  final r2 = new MyResource();
  final r3 = new MyResource();
  final list = new DisposableList<MyResource>()..addAll([r0, r1, r2]);

  list[0] = r3;
  print(r0.isDisposed);
  // => true

  list.dispose();
  print(r1.isDisposed);
  // => true
  print(r2.isDisposed);
  // => true
  print(r3.isDisposed);
  // => true
}

