#!/usr/bin/env dart
import 'package:disposable/disposable.dart';

main() {
  final disposable = new Disposable.create(() {
    print('disposed');
  });
  final refCountDisposable = new RefCountDisposable(disposable);

  final disposable1 = refCountDisposable.getDisposable();
  final disposable2 = refCountDisposable.getDisposable();

  disposable1.dispose();
  print(disposable.isDisposed);
  // => false

  disposable2.dispose();
  print(disposable.isDisposed);
  // => false

  print(refCountDisposable.isDisposed);
  // => false

  refCountDisposable.dispose();
  // => disposed

  print(refCountDisposable.isDisposed);
  // => true
}
