library disposable_test.multi_assignment_disposable;

import 'package:disposable/disposable.dart';
import 'package:test/test.dart';

main() {
  group('MultiAssignmentDisposable tests', () {
    test('MultipleAssignmentDisposable', () {
      final m = new MultiAssignmentDisposable();

      var disp1 = false;
      final d1 = new Disposable.create(() {
        disp1 = true;
      });
      m.disposable = d1;
      expect(d1, same(m.disposable));
      expect(m.isDisposed, isFalse);

      var disp2 = false;
      final d2 = new Disposable.create(() {
        disp2 = true;
      });
      m.disposable = d2;
      expect(d2, same(m.disposable));
      expect(m.isDisposed, isFalse);
      expect(disp1, isFalse);

      m.dispose();
      expect(disp2, isTrue);
      expect(m.isDisposed, isTrue);
      // This is the behavior of Rx.NET v1.x.
      expect(m.disposable, isNull);

      var disp3 = false;
      final d3 = new Disposable.create(() {
        disp3 = true;
      });
      m.disposable = d3;
      expect(disp2, isTrue);
      // This is the behavior of Rx.NET v1.x.
      expect(m.disposable, isNull);
      expect(m.isDisposed, isTrue);
    });
  });
}
