library disposable_test.signle_assignment_disposable;

import 'package:disposable/disposable.dart';
import 'package:test/test.dart';

main() {
  group('SingleAssignmentDisposable tests', () {
    test('SingleAssignmentDisposable_SetNull', () {
      final d = new SingleAssignmentDisposable();
      d.disposable = null;
    });

    test('SingleAssignmentDisposable_DisposeAfterSet', () {
      var disposed = false;

      final d = new SingleAssignmentDisposable();
      final dd = new Disposable.create(() {
        disposed = true;
      });
      d.disposable = dd;

      expect(dd, same(d.disposable));

      expect(disposed, isFalse);
      d.dispose();
      expect(disposed, isTrue);
      d.dispose();
      expect(disposed, isTrue);

      expect(d.isDisposed, isTrue);
    });

    test('SingleAssignmentDisposable_DisposeBeforeSet', () {
      var disposed = false;

      final d = new SingleAssignmentDisposable();
      final dd = new Disposable.create(() {
        disposed = true;
      });

      expect(disposed, isFalse);
      d.dispose();
      expect(disposed, isFalse);
      expect(d.isDisposed, isTrue);

      d.disposable = dd;
      expect(disposed, isTrue);
      // This is the behavior of Rx.NET v1.x. RxJS also returns null.
      expect(d.disposable, isNull);

      d.dispose();
      expect(disposed, isTrue);
    });

    test('SingleAssignmentDisposable_SetMultipleTimes', () {
      final d = new SingleAssignmentDisposable();
      d.disposable = new Disposable();

      expect(() => d.disposable = new Disposable(), throwsStateError);
    });
  });
}
